#pragma once

#define call_kernel(kernel, BLOCKSIZE_m, WORKSIZE_m, WORKSIZE_n) \
	kernel<BLOCKSIZE_m, WORKSIZE_m, WORKSIZE_n><<< dimGrid, dimBlock >>>(switchParameters, n, ntile);

#define workSizeSwitch_n(kernel, BLOCKSIZE_m, WORKSIZE_m, workSize_n) \
	switch (workSize_n)\
	{\
	case 1:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 1><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 2:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 2><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 3:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 3><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 4:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 4><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 5:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 5><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 6:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 6><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 7:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 7><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 8:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 8><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	default:\
		printf("\n workSizeSwitch_n : workSize not supported. [n = %i workSize_m = %i workSize_n = %i (workSize = %i)]\n", n, workSize_m, workSize_n, workSize_m * workSize_n); \
		exit(EXIT_FAILURE);\
	}

//

#define workSizeSwitch_m_n(kernel, BLOCKSIZE_m, workSize_m, workSize_n) \
	switch (workSize_m)\
	{\
	case 1:\
		workSizeSwitch_n(kernel, BLOCKSIZE_m, 1, workSize_n); break; \
	case 2:\
		workSizeSwitch_n(kernel, BLOCKSIZE_m, 2, workSize_n); break; \
	case 3:\
		workSizeSwitch_n(kernel, BLOCKSIZE_m, 3, workSize_n); break; \
	case 4:\
		workSizeSwitch_n(kernel, BLOCKSIZE_m, 4, workSize_n); break; \
	case 5:\
		workSizeSwitch_n(kernel, BLOCKSIZE_m, 5, workSize_n); break; \
	case 6:\
		workSizeSwitch_n(kernel, BLOCKSIZE_m, 6, workSize_n); break; \
	case 7:\
		workSizeSwitch_n(kernel, BLOCKSIZE_m, 7, workSize_n); break; \
	case 8:\
		workSizeSwitch_n(kernel, BLOCKSIZE_m, 8, workSize_n); break; \
	default:\
		printf("\n workSizeSwitch_m : workSize not supported. [n = %i workSize_m = %i workSize_n = %i (workSize = %i)]\n", n, workSize_m, workSize_n, workSize_m * workSize_n);\
		exit(EXIT_FAILURE);\
	}

#define workSizeSwitchLarge_n(kernel, BLOCKSIZE_m, WORKSIZE_m, workSize_n) \
	switch (workSize_n)\
	{\
	case 1:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 1><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 2:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 2><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 3:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 3><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 4:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 4><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 5:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 5><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 6:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 6><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 7:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 7><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 8:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 8><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 9:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 9><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 10:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 10><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 11:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 11><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 12:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 12><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 13:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 13><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 14:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 14><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 15:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 15><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 16:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 16><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	default:\
		printf("\n workSizeSwitchLarge_n : workSize not supported. [n = %i workSize_m = %i workSize_n = %i (workSize = %i)]\n", n, workSize_m, workSize_n, workSize_m * workSize_n); \
		exit(EXIT_FAILURE);\
	}

#define workSizeSwitchLarge_m(kernel, BLOCKSIZE_m, workSize_m, WORKSIZE_n) \
	switch (workSize_m)\
	{\
	case 1:\
		kernel<BLOCKSIZE_m, 1, WORKSIZE_n><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 2:\
		kernel<BLOCKSIZE_m, 2, WORKSIZE_n><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 3:\
		kernel<BLOCKSIZE_m, 3, WORKSIZE_n><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 4:\
		kernel<BLOCKSIZE_m, 4, WORKSIZE_n><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 5:\
		kernel<BLOCKSIZE_m, 5, WORKSIZE_n><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 6:\
		kernel<BLOCKSIZE_m, 6, WORKSIZE_n><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 7:\
		kernel<BLOCKSIZE_m, 7, WORKSIZE_n><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 8:\
		kernel<BLOCKSIZE_m, 8, WORKSIZE_n><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 9:\
		kernel<BLOCKSIZE_m, 9, WORKSIZE_n><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 10:\
		kernel<BLOCKSIZE_m, 10, WORKSIZE_n><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 11:\
		kernel<BLOCKSIZE_m, 11, WORKSIZE_n><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 12:\
		kernel<BLOCKSIZE_m, 12, WORKSIZE_n><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 13:\
		kernel<BLOCKSIZE_m, 13, WORKSIZE_n><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 14:\
		kernel<BLOCKSIZE_m, 14, WORKSIZE_n><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 15:\
		kernel<BLOCKSIZE_m, 15, WORKSIZE_n><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 16:\
		kernel<BLOCKSIZE_m, 16, WORKSIZE_n><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	default:\
		printf("\n workSizeSwitchLarge_m : workSize not supported. [n = %i workSize_m = %i workSize_n = %i (workSize = %i)]\n", n, workSize_m, WORKSIZE_n, workSize_m * WORKSIZE_n);\
		exit(EXIT_FAILURE);\
	}

#define workSizeSwitchLarge_m_n(kernel, BLOCKSIZE_m, workSize_m, workSize_n) \
	switch (workSize_m)\
	{\
	case 1:\
		workSizeSwitch_n(kernel, BLOCKSIZE_m, 1, workSize_n); break; \
	case 2:\
		workSizeSwitch_n(kernel, BLOCKSIZE_m, 2, workSize_n); break; \
	case 3:\
		workSizeSwitch_n(kernel, BLOCKSIZE_m, 3, workSize_n); break; \
	case 4:\
		workSizeSwitch_n(kernel, BLOCKSIZE_m, 4, workSize_n); break; \
	case 5:\
		workSizeSwitch_n(kernel, BLOCKSIZE_m, 5, workSize_n); break; \
	case 6:\
		workSizeSwitch_n(kernel, BLOCKSIZE_m, 6, workSize_n); break; \
	case 7:\
		workSizeSwitch_n(kernel, BLOCKSIZE_m, 7, workSize_n); break; \
	case 8:\
		workSizeSwitch_n(kernel, BLOCKSIZE_m, 8, workSize_n); break; \
	case 9:\
		workSizeSwitch_n(kernel, BLOCKSIZE_m, 9, workSize_n); break; \
	case 10:\
		workSizeSwitch_n(kernel, BLOCKSIZE_m, 10, workSize_n); break; \
	case 11:\
		workSizeSwitch_n(kernel, BLOCKSIZE_m, 11, workSize_n); break; \
	case 12:\
		workSizeSwitch_n(kernel, BLOCKSIZE_m, 12, workSize_n); break; \
	case 13:\
		workSizeSwitch_n(kernel, BLOCKSIZE_m, 13, workSize_n); break; \
	case 14:\
		workSizeSwitch_n(kernel, BLOCKSIZE_m, 14, workSize_n); break; \
	case 15:\
		workSizeSwitch_n(kernel, BLOCKSIZE_m, 15, workSize_n); break; \
	case 16:\
		workSizeSwitch_n(kernel, BLOCKSIZE_m, 16, workSize_n); break; \
	default:\
		printf("\n workSizeSwitchLarge_m_n : workSize not supported. [n = %i workSize_m = %i workSize_n = %i (workSize = %i)]\n", n, workSize_m, workSize_n, workSize_m * workSize_n);\
		exit(EXIT_FAILURE);\
	}

#define workSizeSwitch_m_Large_n(kernel, BLOCKSIZE_m, workSize_m, workSize_n) \
	switch (workSize_m)\
	{\
	case 1:\
		workSizeSwitchLarge_n(kernel, BLOCKSIZE_m, 1, workSize_n); break; \
	case 2:\
		workSizeSwitchLarge_n(kernel, BLOCKSIZE_m, 2, workSize_n); break; \
	case 3:\
		workSizeSwitchLarge_n(kernel, BLOCKSIZE_m, 3, workSize_n); break; \
	case 4:\
		workSizeSwitchLarge_n(kernel, BLOCKSIZE_m, 4, workSize_n); break; \
	case 5:\
		workSizeSwitchLarge_n(kernel, BLOCKSIZE_m, 5, workSize_n); break; \
	case 6:\
		workSizeSwitchLarge_n(kernel, BLOCKSIZE_m, 6, workSize_n); break; \
	case 7:\
		workSizeSwitchLarge_n(kernel, BLOCKSIZE_m, 7, workSize_n); break; \
	case 8:\
		workSizeSwitchLarge_n(kernel, BLOCKSIZE_m, 8, workSize_n); break; \
	default:\
		printf("\n workSizeSwitch_m_Large_n : workSize not supported. [n = %i workSize_m = %i workSize_n = %i (workSize = %i)]\n", n, workSize_m, workSize_n, workSize_m * workSize_n);\
		exit(EXIT_FAILURE);\
	}

#define workSizeSwitchVeryLarge_n(kernel, BLOCKSIZE_m, WORKSIZE_m, workSize_n) \
	switch (workSize_n)\
	{\
	case 1:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 1><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 2:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 2><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 3:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 3><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 4:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 4><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 5:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 5><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 6:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 6><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 7:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 7><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 8:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 8><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 9:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 9><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 10:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 10><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 11:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 11><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 12:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 12><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 13:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 13><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 14:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 14><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 15:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 15><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 16:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 16><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 17:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 17><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 18:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 18><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 19:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 19><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 20:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 20><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 21:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 21><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 22:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 22><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 23:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 23><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 24:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 24><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 25:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 25><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 26:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 26><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 27:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 27><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 28:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 28><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 29:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 29><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 30:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 30><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 31:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 31><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 32:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 32><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 64:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 64><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 128:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 128><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 256:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 256><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	default:\
		printf("\n workSizeSwitchVeryLarge_n : workSize not supported. [n = %i workSize_m = %i workSize_n = %i (workSize = %i)]\n", n, workSize_m, workSize_n, workSize_m * workSize_n); \
		exit(EXIT_FAILURE);\
	}

		//	case 33:													\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 33><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 34:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 34><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 35:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 35><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 36:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 36><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 37:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 37><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 38:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 38><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 39:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 39><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 40:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 40><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 41:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 41><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 42:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 42><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 43:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 43><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 44:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 44><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 45:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 45><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 46:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 46><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 47:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 47><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 48:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 48><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 49:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 49><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 50:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 50><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 51:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 51><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 52:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 52><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 53:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 53><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 54:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 54><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 55:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 55><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 56:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 56><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 57:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 57><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 58:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 58><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 59:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 59><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 60:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 60><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 61:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 61><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 62:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 62><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 63:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 63><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 64:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 64><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \

#define workSizeSwitch_m_VeryLarge_n(kernel, BLOCKSIZE_m, workSize_m, workSize_n) \
	switch (workSize_m)\
	{\
	case 1:\
		workSizeSwitchVeryLarge_n(kernel, BLOCKSIZE_m, 1, workSize_n); break; \
	case 2:\
		workSizeSwitchVeryLarge_n(kernel, BLOCKSIZE_m, 2, workSize_n); break; \
	case 3:\
		workSizeSwitchVeryLarge_n(kernel, BLOCKSIZE_m, 3, workSize_n); break; \
	case 4:\
		workSizeSwitchVeryLarge_n(kernel, BLOCKSIZE_m, 4, workSize_n); break; \
	case 5:\
		workSizeSwitchVeryLarge_n(kernel, BLOCKSIZE_m, 5, workSize_n); break; \
	case 6:\
		workSizeSwitchVeryLarge_n(kernel, BLOCKSIZE_m, 6, workSize_n); break; \
	case 7:\
		workSizeSwitchVeryLarge_n(kernel, BLOCKSIZE_m, 7, workSize_n); break; \
	case 8:\
		workSizeSwitchVeryLarge_n(kernel, BLOCKSIZE_m, 8, workSize_n); break; \
	default:\
		printf("\n workSizeSwitch_m_VeryLarge_n : workSize not supported. [n = %i workSize_m = %i workSize_n = %i (workSize = %i)]\n", n, workSize_m, workSize_n, workSize_m * workSize_n);\
		exit(EXIT_FAILURE);\
	}

#define workSizeSwitchSmallPow_n(kernel, BLOCKSIZE_m, WORKSIZE_m, workSize_n) \
	switch (workSize_n)\
	{\
	case 1:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 1><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 2:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 2><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 4:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 4><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 8:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 8><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 16:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 16><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	default:\
		printf("\n workSizeSwitchSmallPow_n : workSize not supported. [n = %i workSize_m = %i workSize_n = %i (workSize = %i)]\n", n, workSize_m, workSize_n, workSize_m * workSize_n); \
		exit(EXIT_FAILURE);\
	}
#define workSizeSwitchPow_n(kernel, BLOCKSIZE_m, WORKSIZE_m, workSize_n) \
	switch (workSize_n)\
	{\
	case 1:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 1><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 2:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 2><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 4:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 4><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 8:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 8><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 16:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 16><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 32:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 32><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 64:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 64><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 128:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 128><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 256:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 256><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 512:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 512><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	case 1024:\
		kernel<BLOCKSIZE_m, WORKSIZE_m, 1024><<< dimGrid, dimBlock >>>(switchParameters, n, ntile); break; \
	default:\
		printf("\n workSizeSwitch_n : workSize not supported. [n = %i workSize_m = %i workSize_n = %i (workSize = %i)]\n", n, workSize_m, workSize_n, workSize_m * workSize_n); \
		exit(EXIT_FAILURE);\
	}

#define workSizeSwitch_m_Pow_n(kernel, BLOCKSIZE_m, workSize_m, workSize_n) \
	switch (workSize_m)\
	{\
	case 1:\
		workSizeSwitchPow_n(kernel, BLOCKSIZE_m, 1, workSize_n); break; \
	case 2:\
		workSizeSwitchPow_n(kernel, BLOCKSIZE_m, 2, workSize_n); break; \
	case 3:\
		workSizeSwitchPow_n(kernel, BLOCKSIZE_m, 3, workSize_n); break; \
	case 4:\
		workSizeSwitchPow_n(kernel, BLOCKSIZE_m, 4, workSize_n); break; \
	case 5:\
		workSizeSwitchPow_n(kernel, BLOCKSIZE_m, 5, workSize_n); break; \
	case 6:\
		workSizeSwitchPow_n(kernel, BLOCKSIZE_m, 6, workSize_n); break; \
	case 7:\
		workSizeSwitchPow_n(kernel, BLOCKSIZE_m, 7, workSize_n); break; \
	case 8:\
		workSizeSwitchPow_n(kernel, BLOCKSIZE_m, 8, workSize_n); break; \
	default:\
		printf("\n workSizeSwitch_m_Pow_n : workSize not supported. [n = %i workSize_m = %i workSize_n = %i (workSize = %i)]\n", n, workSize_m, workSize_n, workSize_m * workSize_n);\
		exit(EXIT_FAILURE);\
	}

