#define initialize_sums(WORKSIZE_m)								\
	float sum[WORKSIZE_m];										\
    if (WORKSIZE_m >= 1) sum[0] = 0.0;							\
	if (WORKSIZE_m >= 2) sum[1] = 0.0;							\
	if (WORKSIZE_m >= 3) sum[2] = 0.0;							\
	if (WORKSIZE_m >= 4) sum[3] = 0.0;							\
	if (WORKSIZE_m >= 5) sum[4] = 0.0;							\
	if (WORKSIZE_m >= 6) sum[5] = 0.0;							\
	if (WORKSIZE_m >= 7) sum[6] = 0.0;							\
	if (WORKSIZE_m >= 8) sum[7] = 0.0;

#define add_to_sums(BLOCKSIZE, WORKSIZE_m)					\
	if (WORKSIZE_m >= 1) sum[0] += A[0] * x_s[k];				\
	if (WORKSIZE_m >= 2) sum[1] += A[BLOCKSIZE] * x_s[k];		\
	if (WORKSIZE_m >= 3) sum[2] += A[2 * BLOCKSIZE] * x_s[k];	\
	if (WORKSIZE_m >= 4) sum[3] += A[3 * BLOCKSIZE] * x_s[k];	\
	if (WORKSIZE_m >= 5) sum[4] += A[4 * BLOCKSIZE] * x_s[k];	\
	if (WORKSIZE_m >= 6) sum[5] += A[5 * BLOCKSIZE] * x_s[k];	\
	if (WORKSIZE_m >= 7) sum[6] += A[6 * BLOCKSIZE] * x_s[k];	\
	if (WORKSIZE_m >= 8) sum[7] += A[7 * BLOCKSIZE] * x_s[k];

#define add_to_sums_check_bounds(row, mrest, BLOCKSIZE, WORKSIZE_m)			\
	if (WORKSIZE_m >= 1) sum[0] += A[0] * x_s[k];							\
	if (WORKSIZE_m >= 2 && row + BLOCKSIZE < mrest) sum[1] += A[BLOCKSIZE] * x_s[k]; \
	if (WORKSIZE_m >= 3 && row + 2 * BLOCKSIZE < mrest) sum[2] += A[2 * BLOCKSIZE] * x_s[k]; \
	if (WORKSIZE_m >= 4 && row + 3 * BLOCKSIZE < mrest) sum[3] += A[3 * BLOCKSIZE] * x_s[k]; \
	if (WORKSIZE_m >= 5 && row + 4 * BLOCKSIZE < mrest) sum[4] += A[4 * BLOCKSIZE] * x_s[k]; \
	if (WORKSIZE_m >= 6 && row + 5 * BLOCKSIZE < mrest) sum[5] += A[5 * BLOCKSIZE] * x_s[k]; \
	if (WORKSIZE_m >= 7 && row + 6 * BLOCKSIZE < mrest) sum[6] += A[6 * BLOCKSIZE] * x_s[k]; \
	if (WORKSIZE_m >= 8 && row + 7 * BLOCKSIZE < mrest) sum[7] += A[7 * BLOCKSIZE] * x_s[k];

#define atomicAdd_sums(BLOCKSIZE)\
	if (WORKSIZE_m >= 1) atomicAdd(y, alpha * sum[0]);\
	if (WORKSIZE_m >= 2) atomicAdd(y + BLOCKSIZE, alpha * sum[1]);\
	if (WORKSIZE_m >= 3) atomicAdd(y + 2 * BLOCKSIZE, alpha * sum[2]);\
	if (WORKSIZE_m >= 4) atomicAdd(y + 3 * BLOCKSIZE, alpha * sum[3]);\
	if (WORKSIZE_m >= 5) atomicAdd(y + 4 * BLOCKSIZE, alpha * sum[4]);\
	if (WORKSIZE_m >= 6) atomicAdd(y + 5 * BLOCKSIZE, alpha * sum[5]);\
	if (WORKSIZE_m >= 7) atomicAdd(y + 6 * BLOCKSIZE, alpha * sum[6]);\
	if (WORKSIZE_m >= 8) atomicAdd(y + 7 * BLOCKSIZE, alpha * sum[7]);

#define atomicAdd_sums_check_bounds(row, mrest, BLOCKSIZE)	\
	if (WORKSIZE_m >= 1) atomicAdd(y, alpha * sum[0]);\
	if (WORKSIZE_m >= 2 && row + BLOCKSIZE < mrest) atomicAdd(y + BLOCKSIZE, alpha * sum[1]);\
	if (WORKSIZE_m >= 3 && row + 2 * BLOCKSIZE < mrest) atomicAdd(y + 2 * BLOCKSIZE, alpha * sum[2]);\
	if (WORKSIZE_m >= 4 && row + 3 * BLOCKSIZE < mrest) atomicAdd(y + 3 * BLOCKSIZE, alpha * sum[3]);\
	if (WORKSIZE_m >= 5 && row + 4 * BLOCKSIZE < mrest) atomicAdd(y + 4 * BLOCKSIZE, alpha * sum[4]);\
	if (WORKSIZE_m >= 6 && row + 5 * BLOCKSIZE < mrest) atomicAdd(y + 5 * BLOCKSIZE, alpha * sum[5]);\
	if (WORKSIZE_m >= 7 && row + 6 * BLOCKSIZE < mrest) atomicAdd(y + 6 * BLOCKSIZE, alpha * sum[6]);\
	if (WORKSIZE_m >= 8 && row + 7 * BLOCKSIZE < mrest) atomicAdd(y + 7 * BLOCKSIZE, alpha * sum[7]);

// Tall and Skinny special macros
#define atomicAdd_ts(y, arg, sum) y[arg] = sum

#define atomicAdd_sums_ts(BLOCKSIZE)							\
	if (WORKSIZE_m >= 1) atomicAdd_ts(y, 0, alpha * sum[0]);				\
	if (WORKSIZE_m >= 2) atomicAdd_ts(y, BLOCKSIZE, alpha * sum[1]);		\
	if (WORKSIZE_m >= 3) atomicAdd_ts(y, 2 * BLOCKSIZE, alpha * sum[2]);	\
	if (WORKSIZE_m >= 4) atomicAdd_ts(y, 3 * BLOCKSIZE, alpha * sum[3]);	\
	if (WORKSIZE_m >= 5) atomicAdd_ts(y, 4 * BLOCKSIZE, alpha * sum[4]);	\
	if (WORKSIZE_m >= 6) atomicAdd_ts(y, 5 * BLOCKSIZE, alpha * sum[5]);	\
	if (WORKSIZE_m >= 7) atomicAdd_ts(y, 6 * BLOCKSIZE, alpha * sum[6]);	\
	if (WORKSIZE_m >= 8) atomicAdd_ts(y, 7 * BLOCKSIZE, alpha * sum[7]);

#define atomicAdd_sums_check_bounds_ts(row, mrest, BLOCKSIZE)	\
	if (WORKSIZE_m >= 1) atomicAdd_ts(y, 0, alpha * sum[0]);						\
	if (WORKSIZE_m >= 2 && row + BLOCKSIZE < mrest) atomicAdd_ts(y, BLOCKSIZE, alpha * sum[1]);\
	if (WORKSIZE_m >= 3 && row + 2 * BLOCKSIZE < mrest) atomicAdd_ts(y, 2 * BLOCKSIZE, alpha * sum[2]);\
	if (WORKSIZE_m >= 4 && row + 3 * BLOCKSIZE < mrest) atomicAdd_ts(y, 3 * BLOCKSIZE, alpha * sum[3]);\
	if (WORKSIZE_m >= 5 && row + 4 * BLOCKSIZE < mrest) atomicAdd_ts(y, 4 * BLOCKSIZE, alpha * sum[4]);\
	if (WORKSIZE_m >= 6 && row + 5 * BLOCKSIZE < mrest) atomicAdd_ts(y, 5 * BLOCKSIZE, alpha * sum[5]);\
	if (WORKSIZE_m >= 7 && row + 6 * BLOCKSIZE < mrest) atomicAdd_ts(y, 6 * BLOCKSIZE, alpha * sum[6]);\
	if (WORKSIZE_m >= 8 && row + 7 * BLOCKSIZE < mrest) atomicAdd_ts(y, 7 * BLOCKSIZE, alpha * sum[7]);

#define inner_loop(nrest)\	
    for (int k = 0; k < nrest; ++k)\
	{								\
		add_to_sums(BLOCKSIZE_m, WORKSIZE_m); A += lda;	\
	}

#define inner_loop_check_bounds(row, mrest, nrest)\	
    for (int k = 0; k < nrest; ++k)\
	{								\
		add_to_sums_check_bounds(row, mrest, BLOCKSIZE_m, WORKSIZE_m); A += lda; \
	}

// Several cols special macros

#define inner_loop_sf(nrest)\	
    for (int k = 0; k < nrest; k += WORKSIZE_m)\
	{								\
		sum += A[0] * x_s[k + tidcol];			\
		A += WORKSIZE_m * lda;					\
	}

#define inner_loop_sc(thenrest)\	
    for (int k = 0; k < thenrest; k += workSize_m)\
	{								\
		sum += A[0] * x_s[k + tidcol];			\
		A += workSize_m * lda;					\
	}

#define inner_loop_g2(nrest)\	
    for (int k = 0; k < nrest; ++k)\
	{								\
		sum += A[0] * x_s[k]; A += lda;	\
	}

